unit ResIcon;

interface

uses
  SysUtils, Classes, Graphics;

type
  TResourceIcon = class(TIcon)
  private
    function GetIcons(ID: string): TIcon;
  public
    property Icons[ID: string]: TIcon read GetIcons; default;
		constructor Create; override;
    destructor Destroy; override;
  end;
  EResourceIcon = class(Exception);
  EIconNotFound = class(EResourceIcon);

implementation

uses
	Windows, ShellAPI, Forms;

function TResourceIcon.GetIcons(ID: string): TIcon;
begin

  ReleaseHandle;
  Handle := LoadIcon(hInstance,PChar(ID));
  if Handle = 0 then begin
	  Handle := ExtractIcon(HInstance,PChar(Application.ExeName),0);
	  Result := Self;
  	raise EIconNotFound.Create(Self.ClassName + ' - Icon not found, ID: ' + ID);
  end
  else
	  Result := Self;

end;

constructor TResourceIcon.Create;
begin

  inherited Create;
  ReleaseHandle;
  Handle := ExtractIcon(HInstance,PChar(Application.ExeName),0);

end;

destructor TResourceIcon.Destroy;
begin

  ReleaseHandle;
	inherited Destroy;

end;


end.
